/*
 * File: Circle.h
 * --------------
 * "Derived" class: Circle
 * The shape interface must be available to it.
 */

#ifndef CIRCLE_H
#define CIRCLE_H

#include "Shape.h"

typedef struct CircleCDT *Circle;

// Access to the interface (base class)
Shape CircleShape(Circle circle);
// Derived class constructor when the base "shape" is already constructed.
// There is no need for matching destructor because the deletion of the
// derived part is done automatically when the interface (base) is deleted
Circle CircleCreate(Shape shape, float radius);
// Circle methods
int CircleCounter(void); // class method
float CircleGetRadius(Circle circle);
void CircleSetRadius(Circle circle, float new_radius);

// DO NOT USE THIS FUNCTION! See comments in implementation in Circle.c for reasons.
void CircleDelete(Circle *circlePtr); // DON'T USE!

#endif // CIRCLE_H

