/*
 * File: Rectangle.h
 * -----------------
 * "Derived" class: Rectangle
 * The shape interface must be available to it.
 */

#ifndef RECTANGLE_H
#define RECTANGLE_H

#include "Shape.h"

typedef struct RectangleCDT *Rectangle;

// The access to the interface (base class)
Shape RectangleShape(Rectangle rect);
// Derived class constructor when the base "shape" is already constructed
Rectangle RectangleCreate(Shape shape, float width, float height);
// Rectangle methods
int RectangleCounter(void); // class method
float RectangleGetWidth(Rectangle rect);
void RectangleSetWidth(Rectangle rect, float new_width);
// we can arbitrarily make the "height" inaccessible to the user :)

#endif // RECTANGLE_H
